{
TASK:burn
LANG:pascal
}
program burn;

const
	MAXN				= 100;
	MAXM				= 6000;
	INF				= 100000000;

type
	Integer				= LongInt;
	TNode				= record
		i, j, l			: Integer;
	end;

var
	G				: Array [1 .. MAXN, 1 .. MAXN] of Integer;
	used				: Array [1 .. MAXN] of Boolean;
	Lev				: Array [1 .. MAXN] of Integer;
	R				: Array [1 .. MAXM] of TNode;
	D				: Array [1 .. MAXN] of Integer;
	c				: Integer;
	min, i_min			: Integer;
	N, M, i, j			: Integer;

procedure Init;
begin
	for i := 1 to N do begin
		Lev[i] := 0;
		for j := 1 to N do
			G[i, j] := INF;
	end;
end;

procedure readInput;
var
	a, b, l				: Integer;
begin
	readln(N, M);
	Init;
	for i := 1 to M do begin
		readln(a, b, l);
		R[i].i := a;
		R[i].j := b;
		R[i].l := l;
		if (G[a, b] > l) then begin
			G[a, b] := l;
			G[b, a] := l;
		end;
		Lev[a] := Lev[a] + 1;
		Lev[b] := Lev[b] + 1;
		if (a = b) then Lev[a] := Lev[a] - 1;
	end;
end;

procedure dijkstra(x: Integer);
begin
	for i := 1 to N do
		D[i] := G[x, i] + Lev[x];
	D[x] := 0;
	used[x] := True;
	for i := 1 to (N-1) do begin
		min := INF;
		for j := 1 to N do
			if (not used[j]) and (D[j] < min) then begin
				min := D[j];
				i_min := j;
			end;
		c := i_min;
		used[c] := True;
		for j := 1 to N do
			if (D[c] + Lev[c] + G[c, j] < D[j]) then
				D[j] := D[c] + Lev[c] + G[c, j];
	end;
end;

function max(a, b: Integer): Integer;
begin
	if (a > b) then
		max := a
	else
		max := b;
end;

function calc(t1, t2, l: Integer): Real;
var
	tmp			: Real;
begin
	if (abs(t1-t2)>=l) then
		calc := max(t1, t2)
	else begin
		tmp := max(t1, t2);
		l := l - (abs(t1-t2));
		tmp := tmp + l/2;
                calc := tmp;
	end;
end;

procedure Solve;
var
	i, j					: Integer;
	min					: Real;
	max					: Real;
	a, b, l					: Integer;
	time					: Real;
begin
	min := INF;
	for i := 1 to N do begin
		dijkstra(i);
		max := 0;
		for j := 1 to M do begin
			a := R[j].i;
			b := R[j].j;
			l := R[j].l;
			if (max < D[a] + Lev[a]) then
				max := D[a] + Lev[a];
			if (max < D[b] + Lev[b]) then
				max := D[b] + Lev[b];
			time := calc(D[a] + Lev[a], D[b] + Lev[b], l);
			if (max < time) then
				max := time;
		end;
		if (min > max) then
			min := max;
	end;
	writeln(min:1:1);
end;

begin
	readInput;
	Solve;
end.