{
TASK:treas
LANG:pascal
}
program treas;

const
	MAXN				= 1000;
	MAXXC				= 25000;

type
	Integer				= LongInt;
	TTreasure			= record
		x, y, p			: Integer;
		a, b			: Integer;
	end;

var
	t				: Array [1 .. MAXN] of TTreasure;
	m, p				: Array [1 .. MAXN] of TTreasure;
	mn, pn				: Integer;
	cmax				: Integer;
	N, i, j				: Integer;
	used				: Array [1 .. MAXN] of Boolean;
	max				: Integer;

procedure readInput;
begin
	readln(N);
	for i := 1 to N do begin
		readln(t[i].x, t[i].y, t[i].p);
		t[i].a := t[i].x - (abs(t[i].y)-1);
		t[i].b := t[i].x + (abs(t[i].y)-1);
	end;
end;

function pr(y: Integer): Integer;
var
	t				: Integer;
begin
	t := abs(y);
	pr := ((t*(t+1)) div 2) + ((t*(t-1)) div 2);
end;

function cross(x1, y1, x2, y2: Integer): Boolean;
begin
	if ((x2 < x1) and (y2 > y1)) then cross := True else
	if ((x1 < x2) and (y1 > y2)) then cross := True else
	if ((x2 < x1) and (y2 > x1)) then cross := True else
	if ((x2 < y1) and (y2 > y1)) then cross := True else
		cross := False;
end;

procedure check;
var
	i, j, k, z			: Integer;
	x				: Array [-MAXXC..MAXXC] of Integer;
begin
	k := 0;
	for i := 1 to pn do
		k := k + p[i].p;
	for i := -MAXXC to MAXXC do x[i] := 0;
	for i := 1 to pn do begin
		for j := p[i].a to p[i].b do begin
			z := abs(p[i].y) - abs(j-p[i].x);
			if (x[j] < z) then begin
				k := k - (z - x[j]);
                                x[j] := z;
			end;
		end;
	end;
	if (k > cmax) then
		cmax := k;
end;

procedure go(c: Integer);
begin
	if (c = mn+1) then begin
		check;
	end else begin
		pn := pn + 1;
		p[pn] := m[c];
		go(c+1);
		pn := pn - 1;
		go(c+1);
	end;
end;

procedure Solve;
var
	free				: Boolean;
begin	
	max := 0;
	for i := 1 to N do
		used[i] := False;
	for i := 1 to N do
		if (not used[i]) then begin
			free := True;
			used[i] := True;
			for j := 1 to N do
				if (i <> j) then
					if (cross(t[i].a, t[i].b, t[j].a, t[j].b)) then begin
						free := False;
						break;
					end;
			if (free) then begin
				if ((t[i].p - pr(t[i].y)) > 0) then
					max := max + (t[i].p - pr(t[i].y));
			end else begin
				mn := 1;
				m[mn] := t[i];
				for j := 1 to N do 
					if (i <> j) then
						if (cross(t[i].a, t[i].b, t[j].a, t[j].b)) then begin
							used[j] := True;
							mn := mn + 1;
							m[mn] := t[j];
						end;
				pn := 0;
				cmax := 0;
				go(1);
				max := max + cmax;
			end;
		end;
end;

procedure writeOutput;
begin
	writeln(max);
end;

begin
	readInput;
	Solve;
	writeOutput;
end.