/*
TASK:BURN
LANG:C++
*/

#include <time.h>
#include <stdio.h>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <algorithm>
#include <values.h>
#include <float.h>
#include <math.h>

using namespace std;

#define IN "gen.out"
#define OUT "burn.out"
#define mp pake_pair
#define sz size()
#define pb push_back

#define LEFT 0
#define RIGHT 1
#define MAXN 256
#define MAXM 8192
#define EQ(a,b) ((fabs(a-b) < DBL_EPSILON)?(1):(0))
#define MIN(a,b) (((a)<(b))?(a):(b))

int N,M;

typedef struct node {
        int d,l,end,id;
        node () {
             d = l = end = id = 0;
        }
        node (int d1,int l1,int end1,int id1) {
             d = d1;
             l = l1;
             end = end1;
             id = id1;
        }
};

typedef struct vertex{
        double end;
        int v;
        vertex () {
               end = 0;
               v = 0;
        }
        vertex (double end1,int v1) {
               end = end1;
               v = v1;
        }
        bool operator < (const vertex &h) const {
             if (EQ(end,h.end)) {
                if (v < h.v) return true;
                else return false;
             } else {
                if (end < h.end) return true;
                else return false;
             }
             
        }
};

typedef struct edge {
        double end;
        int id;
        edge () {
             end = 0;
             id = 0;
        }
        edge (double end1,int v1) {
               end = end1;
               id = v1;
        }
        bool operator < (const edge &h) const {
             if (EQ(end,h.end)) {
                if (id < h.id) return true;
                else return false;
             } else {
                if (end < h.end) return true;
                else return false;
             }
             
        }

};


vector <node> ar[MAXN];
vector <int> br[MAXM];
int stepen[MAXN] = {};
int len[MAXM] = {};
int r[MAXN] = {};

set <vertex> vset;
set <vertex> :: iterator vi;
set <edge> eset;
set <edge> :: iterator ei;

double vend[MAXN] = {};
double E[2][MAXM] = {};
double eend[MAXM] = {};
double ret = 0.0;
double ans;
vertex v;
edge e;

inline int calc (int id) {
       if (EQ(E[0][id],DBL_MAX) && EQ(E[1][id],DBL_MAX)) return 0;
       
       if (EQ(E[0][id],DBL_MAX)) {
          eend[id] = E[1][id] + len[id];
          return 0;
       }
       if (EQ(E[1][id],DBL_MAX)) {
          eend[id] = E[0][id] + len[id];
          return 0;
       }

       if (fabs(E[0][id] - E[1][id]) > len[id]) {
          eend[id] = MIN(E[0][id],E[1][id]) + len[id];
          return 0;
       }

       double x;
       double a,b;
       if (E[0][id] > E[1][id]) {
          a = E[0][id];
          b = E[1][id];
       } else {
          a = E[1][id];
          b = E[0][id];
       }

       x = (a-b+len[id])/2;
       eend[id] = b+x;
       return 0;
}

int id;

inline int update_vertex_set() {
    v = (*vi);
    for (int i=0; i<stepen[v.v]; i++) {
        id = ar[v.v][i].id;
        if (ar[v.v][i].end == 0) {
           if (E[0][id] > v.end) {
              E[0][id] = v.end;
              eset.erase(edge(eend[id],id));
              calc(id);
              eset.insert(edge(eend[id],id));
           }
         } else {
           if (E[1][id] > v.end) {
              E[1][id] = v.end;
              eset.erase(edge(eend[id],id));
              calc(id);
              eset.insert(edge(eend[id],id));
           }
         }
    }
    vset.erase(vi);
}

inline int update_edge_set() {
    e = (*ei);
    id = e.id;
    for (int i=0; i<br[id].size(); i++) {
        if (vend[br[id][i]] > eend[id]+stepen[br[id][i]]) {
           vset.erase(vertex(vend[br[id][i]],br[id][i]));
           vend[br[id][i]] = eend[id]+stepen[br[id][i]];
           vset.insert(vertex(vend[br[id][i]],br[id][i]));
        }
    }
    eset.erase(ei);
}
double start_fire (int s) {

       ret = 0.0;
       for (int i=1; i<=N; i++) {vend[i] = DBL_MAX;}
       for (int i=1; i<=M; i++) {eend[i] = DBL_MAX;}
       for (int i=1; i<=M; i++) {E[0][i] = E[1][i] = DBL_MAX;}
       
       vend[s] = stepen[s];
       vset.insert(vertex(stepen[s],s));


       while (1) {
       
             ei = eset.begin();
             vi = vset.begin();
       

             if ((*ei).end > ans && (*vi).end > ans) return DBL_MAX;
             
             if (ei == eset.end() && vi == vset.end()) break;
             
             if (ei == eset.end()) {
                update_vertex_set();
                continue;
             }
             if (vi == vset.end()) {
                update_edge_set();
                continue;
                
             }

             if ((*vi).end < (*ei).end) {
                update_vertex_set();
             } else {
                update_edge_set();
             }
       }

       for (int i=1; i<=N; i++) {
           ret >?= vend[i];
       }
       for (int i=1; i<=M; i++) {
           ret >?= eend[i];
       }
       
       return ret;
}

int main () {

    clock();

//    freopen(IN,"r",stdin);
//    freopen(OUT,"w",stdout);


    scanf("%d%d",&N,&M);
    int a,b,c;
    for (int i=1; i<=M; i++) {
        scanf("%d%d%d",&a,&b,&c);
        ar[a].pb(node(b,c,LEFT,i));
        ar[b].pb(node(a,c,RIGHT,i));
        br[i].pb(a);
        br[i].pb(b);
        len[i] = c;
    }
    for (int i=1; i<=N; i++) {
        stepen[i] = ar[i].size();
        r[i] = i;
    }

    random_shuffle(&r[1],&r[1]+N);

    ans = DBL_MAX;
    double t;
    for (int i=1; i<=N; i++) {
        t = start_fire(r[i]);
        ans <?= t;
        if ((double)clock() > (double)0.95*CLOCKS_PER_SEC) {
           break;
        }
    }
    printf("%.1lf\n",ans);
    return 0;
}
