/*
TASK:burn
LANG:C++
*/
#include <cstdio>
#include <cstdlib>
#include <queue>
#include <algorithm>
using namespace std;

#define MAXN 128
#define MAXM 6002

struct TNish {
       int a,b,t,l;
}Nish[MAXM];

struct HeapCmp {
       bool operator() (int a, int b)
       {
                  return (Nish[a].t+Nish[a].l) > (Nish[b].t+Nish[b].l);
       }
};
              
priority_queue<int, vector<int>, HeapCmp> Heap;


int Gmin[MAXN][MAXN];
int Gmax[MAXN][MAXN];
int D[MAXN];
int N, M;

void Init(void) {
     int a,b,l,i;
     scanf("%d%d",&N,&M);
     for(i=1; i<=M; i++)
     {
              scanf("%d%d%d",&a,&b,&l);
              D[a]++;  D[b]++;
              if(Gmin[a][b]==0 || l<Nish[Gmin[a][b]].l) { Gmin[a][b] = i; Gmin[b][a] = i; }
              if(Gmax[a][b]==0 || l>Nish[Gmax[a][b]].l) { Gmax[a][b] = i; Gmax[b][a] = i; }
              
              Nish[i].a=a; Nish[i].b=b; Nish[i].l=l;
     }
     /*for(i=1; i<=N; i++)
              for(int j=i+1; j<=N; j++)
              {
                      if(Gmin[i][j]) printf("%d %d %d %d\n",i,j,Nish[Gmin[i][j]].l,Nish[Gmax[i][j]].l);
              }*/
}
     
double Try(int v) {
       int Burned[MAXN];
       double BurnN[MAXM];
       int BurnV[MAXN];
       int UsedN[MAXM];
       int a,b;
       
       memset(Burned,0,sizeof(Burned));
       memset(UsedN,0,sizeof(UsedN));
       TNish T;
       Nish[0].a = v; Nish[0].b=v; Nish[0].t=0; Nish[0].l=0;
       Heap.push(0);

       while(!(Heap.empty())) {
             int w = Heap.top(); Heap.pop();                
             if(UsedN[w]==1) continue;
             a=-1; b=-1;
             if(Burned[Nish[w].a]==0) { b=Nish[w].a; a=Nish[w].b; }
             else if(Burned[Nish[w].b]==0) { b=Nish[w].b; a=Nish[w].a; }
             
             if(b==-1) continue;
//                       printf("%d %d %d %d\n",a,b,Nish[w].t,Nish[w].l);
             UsedN[w] = 1;
             BurnN[w] = (double)Nish[w].t+(double)Nish[w].l;
             Burned[b]=1;
             BurnV[b] = Nish[w].t+Nish[w].l;
  //           printf("Burn: %d %d\n",b,BurnV[b]);
             int C = BurnV[b]+D[b];
             for(int x=1; x<=N; x++)
             {
//                     printf("Connection: %d %d %d %d\n",b,x,Nish[Gmin[b][x]].l,Nish[Gmax[b][x]].l);
                      if(Burned[x]==0 && Gmin[b][x]>0)
                      {
                           int p = Gmin[b][x];
                           Nish[p].t =  C;
                           Heap.push(p);
                      }
                      if(Burned[x]==0 && Gmax[b][x]>0 && Gmin[b][x]!=Gmax[b][x])
                      {
                           int p = Gmax[b][x];
                           Nish[p].t =  C;
                           Heap.push(p);
                      }
                      if(Burned[x]==1 && Gmin[b][x]>0)
                      {
                           int p = Gmin[b][x];
                           if(UsedN[p]==0 && Nish[p].l+Nish[p].t>=C)
                           {

                               BurnN[p] =  C+( (double)Nish[p].l-(double)C+(double)Nish[p].t )/(double)2 ; 
                               UsedN[p] = 1;
                           }                                      
                      }
                      
                      if(Burned[x]==1 && Gmax[b][x]>0 && Gmax[b][x]!=Gmin[b][x])
                      {
                           int p = Gmax[b][x];
                           if(UsedN[p]==0 && Nish[p].l+Nish[p].t>=C)
                           {

                               BurnN[p] =  C+( (double)Nish[p].l-(double)C+(double)Nish[p].t )/(double)2 ; 
                               UsedN[p] = 1;
                           }                                      
                      }
             }
       }
       double Max=0;
       for(int i=1; i<=M; i++) { if(BurnN[i]>Max) Max=BurnN[i]; /*printf("%.1lf\n",BurnN[i]);*/ }
       for(int i=1; i<=N; i++) { if(BurnV[i]+D[i]>Max) Max=BurnV[i]+D[i]; /*printf("%d\n",BurnV[i]+D[i]);*/ }
       return Max;
}
       
/*void TestHeap(void) {
     TNish T;
     T.t = 0;   T.l = 2;     Heap.push(T);
     T.t = 0;   T.l = 3;     Heap.push(T);
     T.t = 1;   T.l = 4;     Heap.push(T);
     T.t = 0;   T.l = 1;     Heap.push(T);
     while(!(Heap.empty()))
     {
            T = Heap.top();
            printf("%d %d %d\n",T.t+T.l,T.t,T.l);
            Heap.pop();              
     }
     
}*/
          

int main(void) {
//    TestHeap();
      Init();
      double Best=7000000;
      for(int i=1; i<=N; i++) 
      {
               double T = Try(i);
               if(T<Best) Best=T;
      }
      printf("%.1lf\n",Best);
    return 0;
}

